﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="TestForm.aspx.cs" Inherits="CallbackForFleetTracker.TestForm" %>

<%@ Register Assembly="WebEdition" Namespace="ThinkGeo.MapSuite.WebEdition" TagPrefix="cc1" %>
<%@ Register Src="UC/Footer.ascx" TagName="Footer" TagPrefix="uc1" %>
<%@ Register Src="UC/Header.ascx" TagName="Header" TagPrefix="uc2" %>
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <link href="Theme/css.css" rel="stylesheet" type="text/css" />
    <title>CallbackForFleetTracker</title>

    <script type="text/javascript">
        var olMap = null;
        var markers = null;
        
        var OnMapCreating = function(map) {
            markers = new OpenLayers.Layer.Markers("Markers");
            Map1.GetOpenLayersMap().addLayer(markers);
        };

        var OnMapCreated = function(map) {
            var timer = window.setInterval(Function.createDelegate({ 'args': "args", 'context': document.getElementById('message') }, function(evt) {
                var args = this.args;
                var context = this.context;
                <%=ClientScript.GetCallbackEventReference(this, "args", "Success", "context", "Error", true) %>;
            }), 3000);
        };
        
        function Success(args, context) {
            var vehicles = Sys.Serialization.JavaScriptSerializer.deserialize(args);
            if (markers.markers != null) {
                 while (markers.markers.length > 0) {
                        markers.markers[0].destroy();
                        markers.removeMarker(markers.markers[0]);
                    }
            } 

            olMap = Map1.GetOpenLayersMap();
            if (olMap.popups != null) {
                while (olMap.popups.length > 0) {
                    olMap.popups[0].destroy();
                }
            }
            for(var i = 0; i<vehicles.length; i++)
            {
                var vehicle = vehicles[i];
                var size = new OpenLayers.Size(32, 32);
                var offset = new OpenLayers.Pixel(-(size.w / 2), -size.h);
                var icon = new OpenLayers.Icon('../../theme/' + vehicle.n, size, offset);
         
                var marker = new OpenLayers.Marker(new OpenLayers.LonLat(vehicle.x, vehicle.y), icon);
                markers.addMarker(marker);
                AddPopup(marker, vehicle.id, vehicle.y, vehicle.x, "siteDesc", "DisplayText");
            }
        }

        function Error(args, context) {
            message.innerText = 'EXCEPTION';
        }
        
        function AddPopup(marker, siteId, lat, lon, siteDesc, DisplayText) {
            var tmp_X = 0;
            var tmp_Y = 0;

            var content = "<span class='popup'>\r\n"
            content = content + "<div>" + siteId + "</div>\r\n"
            content = content + "<div>" + siteDesc + "</div>\r\n"
            content = content + "<div>" + DisplayText + "</div>\r\n"
            content = content + "</span>"

            var popup = new OpenLayers.Popup.FramedCloud(siteId,
                   new OpenLayers.LonLat(parseFloat(lon), parseFloat(lat)),
                   new OpenLayers.Size(200, 200),
                   content,
                   null,
                   true);

            olMap = Map1.GetOpenLayersMap();
            olMap.addPopup(popup);
            popup.hide();

            for (i in olMap.popups) {
                if (olMap.popups[i].visible && olMap.popups[i] != popup) {
                    olMap.popups[i].hide();
                }
            }

            marker.events.register('mouseover', popup, function(evt) {
                popup.show();
            });

            marker.events.register('mouseout', popup, function(evt) {
                for (i in olMap.popups) {
                    if (olMap.popups[i].visible) {
                        olMap.popups[i].hide();
                    }
                }
            });
        }
    </script>

</head>
<body>
    <form id="form1" runat="server">
    <table border="0px" width="100%" cellpadding="0px" cellspacing="0px" style="height: 100%;">
        <tr>
            <td style="height: 80px;">
                <uc2:Header ID="Header1" runat="server" />
            </td>
        </tr>
        <tr>
            <td style="height: 100%; border-top: solid 1px #ece9d8;">
                <asp:ScriptManager ID="ScriptManager1" runat="server">
                </asp:ScriptManager>
                <cc1:Map ID="Map1" runat="server" Height="100%" Width="100%">
                </cc1:Map>
            </td>
        </tr>
        <tr>
            <td style="height: 50px; border-top: outset 0px #666666; background-color: #ece9d8;">
                <uc1:Footer ID="Footer1" runat="server" />
            </td>
        </tr>
    </table>
    <div id="Message">
    </div>
    </form>
</body>
</html>
