﻿using System;
using System.Collections.ObjectModel;
using System.Web.UI;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace CallbackForFleetTracker {
    public partial class TestForm : System.Web.UI.Page, ICallbackEventHandler {
        private static string result = string.Empty;
        //Start position for the six vehicles
        private static double[,] startPositions = { { -95.26095, 38.93926 }, { -95.26086, 38.96956 }, { -95.25919, 38.96758 }, { -95.29056, 38.95703 }, { -95.22653, 38.94278 }, { -95.26987, 38.93531 } };
        Collection<JsonVehicle> vehicles = new Collection<JsonVehicle>();

        protected void Page_Load(object sender, EventArgs e) {
            if (!Page.IsPostBack) {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.MapUnit = GeographyUnit.DecimalDegree;
                Map1.CurrentExtent = new RectangleShape(-95.31105, 38.98184, -95.20359, 38.92185);

                Map1.MapTools.OverlaySwitcher.Enabled = true;
                Map1.MapTools.MouseCoordinate.Enabled = true;
                Map1.MapTools.MiniMap.Enabled = true;

                WorldMapKitWmsWebOverlay worldMapKitWmsWebOverlay = new WorldMapKitWmsWebOverlay();
                Map1.CustomOverlays.Add(worldMapKitWmsWebOverlay);
            }
        }

        public void RaiseCallbackEvent(String eventArgument) {
            vehicles.Clear();
            for (int i = 0; i < startPositions.GetLength(0); i++) {
                double lon = startPositions[i, 0] + new Random().Next(-12, 20) / 5000.0;
                double lat = startPositions[i, 1] + new Random().Next(-11, 26) / 5000.0;
                startPositions[i, 0] = lon;
                startPositions[i, 1] = lat;
                JsonVehicle vehicle = new JsonVehicle("vehicle" + (i + 1), "vehicle_van_" + (i + 1) + ".png", lon, lat);
                vehicles.Add(vehicle);
            }
            result = JsonSerializeHelper.Serialize<Collection<JsonVehicle>>(vehicles);
        }

        public string GetCallbackResult() {
            //Return the vehicle data to client using callback
            return result;
        }
    }
}
